/*
 * Booking dates form generator - main routines
 * Copyright (C) 1999 Open World Ltd
 * Written by Shevek <shevek@anarres.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <string.h>
#include "library.h"
#include "vector.h"
#include "smalloc.h"
#include "hash.h"
#include "cgi.h"
#include "log.h"

/* Server data directory for Java
 * /users/oworld/www/hyatt/webletinfo/bookingdates/travelweb/\
 		templates/hotels
 */

void template_parse(rope_t *pathstr);

void
invoke(void)
{
	hash_t		*cgihash;
	rope_t		*pathstr;
	char		*provider;
	char		*template;
	char		*hostname;

	cgihash = cgi_hash_new();

	provider = hash_get(cgihash, "case");
	if (!provider) {
		log("cgiconf", PRI_CRIT, "No value for 'case' in CGI hash");
		exit(0);
	}
	provider[strcspn(provider, "/")] = 0;
	
	template = hash_get(cgihash, "template");
	if (!template){
		log("cgiconf", PRI_CRIT, "No value for 'template in CGI hash");
		exit(0);
	}
	template[strcspn(template, "/")] = 0;

	hostname = getenv(ENV_HOSTNAME);
	if (!hostname) {
		log("cgiconf", PRI_ERR, "No " ENV_HOSTNAME " in environment");
		exit(0);
	}

	pathstr = rope_new(DIR_DATA);
	rope_add(pathstr, hostname);
	rope_add(pathstr, "/bookingdates/");
	rope_add(pathstr, provider);
	rope_add(pathstr, "/");
	rope_add(pathstr, template);
	rope_add(pathstr, ".tpt");

	template_parse(pathstr);
}
